echo off

if "%1" == "" goto usage;
if "%2" == "" goto usage;
if "%3" == "" goto usage;

set old_dbname=%1
set new_dbname=%2
set current_dir=%3
set old_cubrid_databases=%4

set CUBRID_2008=%CUBRID%
set CUBRID_DATABASES_2008=%CUBRID_DATABASES%

if NOT "%old_cubrid_databases%"=="" (
  set CUBRID_DATABASES=%old_cubrid_databases%
)

echo Please select %old_dbname%'s version 
echo 1) 6.6 , 7.0
echo 2) 7.1
echo 3) 7.3

:input
set /p input_val=version ? 

set version_string=
if "%input_val%"=="1" (
  set version_string=6_6
  goto :continue
)

if "%input_val%"=="2" (
  set version_string=7_1
  goto :continue
)

if "%input_val%"=="3" (
  set version_string=7_3
  goto :continue
)

goto :input

:continue

set db_dir=%current_dir%\%version_string%

cd %db_dir%

if NOT "%errorlevel%"=="0" (
  echo Can not change directory to %db_dir%
  goto :ENDOFFILE
)

set CUBRID_2008=%CUBRID%
set CUBRID=%db_dir%
set CUBRID_LANG=En_US
set PATH=%CUBRID%;%PATH%

%CUBRID%\unloaddb -sa -od %CUBRID%\.. %old_dbname%

if NOT "%errorlevel%"=="0" (
  echo unload failed.
  goto :ENDOFFILE  
)

set log_file=%CUBRID%\unload.log

if EXIST %log_file% (
  mv %log_file% %CUBRID%\..
)

set CUBRID=%CUBRID_2008%
set CUBRID_DATABASES=%CUBRID_DATABASES_2008%
set PATH=%CUBRID%;%PATH%

set schema_file=%db_dir%\..\%old_dbname%.sch
set index_file=%db_dir%\..\%old_dbname%.idx
set object_file=%db_dir%\..\%old_dbname%.obs

set load_arg=

if EXIST %schema_file% (
  set load_arg=%load_arg% --schema-file=%schema_file%
)

if EXIST %index_file% (
  set load_arg=%load_arg% --index-file=%index_file%
)

if EXIST %object_file% (
  set load_arg=%load_arg% --data-file=%object_file%
)

set load_arg=%load_arg% --ignore-class-file=%db_dir%\..\ignore_class.txt -u dba %new_dbname% 

%CUBRID%\bin\cub_admin loaddb %load_arg%

if NOT "%errorlevel%"=="0" (
  echo "cub_admin loaddb operation has been failed."
  goto :ENDOFFILE
)

set loadlog_file=%db_dir%\loaddb_%2.log

if EXIST %loadlog_file% (
  move %loadlog_file% %db_dir%\..
)

%CUBRID%\bin\convert_password.exe %new_dbname%

if NOT "%errorlevel%"=="0" (
  echo "Can not convert password."
)

:ENDOFFILE
set CUBRID=%CUBRID_2008%
set CUBRID_DATABASES=%CUBRID_DATABASES_2008%
cd %current_dir%
goto :EOF

:usage
echo "usage : %0 src_database target_database converter_path [old_cubrid_databases_env]"

