#!/bin/sh

convert_program="convert_password"

if [ "${1}" == "" ]; then
  echo "usage : ${0} src_database target_database converter_2008_path [old_cubrid_databases_env]"
  exit 1;
fi

if [ "${2}" == "" ]; then
  echo "usage : ${0} src_database target_database converter_2008_path [old_cubrid_databases_env]"
  exit 1;
fi

if [ "${3}" == "" ]; then
  echo "usage : ${0} src_database target_database converter_2008_path [old_cubrid_databases_env]"
  exit 1;
fi

echo "Please select %old_dbname%'s version"
echo "1) 6.6 , 7.0"
echo "2) 7.1"
echo "3) 7.3"

done=""
while [ "${done}" != "OK" ]
do
  echo -n "version ?"
  read ver_string

  if [ "${ver_string}" == "1" ]; then
    ver_string="6_6"
    done="OK"
  fi

  if [ "${ver_string}" == "2" ]; then
    ver_string="7_1"
    done="OK"
  fi

  if [ "${ver_string}" == "3" ]; then
    ver_string="7_3"
    done="OK"
  fi
done

db_dir=${3}/${ver_string}

cd ${db_dir}
if [ $? != 0 ]; then
  echo "Can not change directory to ${db_dir}"
  exit 1
fi

export CUBRID_2008=${CUBRID}
export CUBRID_DATABASES_2008=${CUBRID_DATABASES}

export CUBRID=${db_dir}
if [ "${4}" != "" ]; then
  export CUBRID_DATABASES=${4}
fi

export CUBRID_LANG="En_US"
export PATH=${CUBRID}/utilities:${PATH}
export LD_LIBRARY_PATH=${CUBRID}/lib:${LD_LIBRARY_PATH}

${db_dir}/utilities/unloaddb -sa -od ${db_dir}/.. ${1}
if [ $? != 0 ]; then
  echo "unloaddb failed."
  exit 1
fi

log_file=${db_dir}/unload.log

if [ -e ${log_file} ]; then
  mv ${log_file} ${db_dir}/..
fi

# unload is done  load to new database
export CUBRID=${CUBRID_2008}
export CUBRID_DATABASES=${CUBRID_DATABASES_2008}
export PATH=${CUBRID}/bin:${CUBRID}/utilities:${PATH}
export LD_LIBRARY_PATH=${CUBRID}/lib:${LD_LIBRARY_PATH}

schema_file=${db_dir}/../${1}_schema
index_file=${db_dir}/../${1}_indexes
object_file=${db_dir}/../${1}_objects

load_arg=""

if [ -e ${schema_file} ]; then
  load_arg="${load_arg} --schema-file=${schema_file}"
fi

if [ -e ${index_file} ]; then
  load_arg="${load_arg} --index-file=${index_file}"
fi

if [ -e ${object_file} ]; then
  load_arg="${load_arg} --data-file=${object_file}"
fi

load_arg="${load_arg} --ignore-class-file=${db_dir}/../ignore_class.txt -u dba ${2}"

echo "${CUBRID}/bin/cub_admin load ${load_arg}"
${CUBRID}/bin/cub_admin loaddb ${load_arg}

if [ $? != 0 ]; then
  echo "cub_admin loaddb failed."
  exit 1
fi

loadlog_file=${db_dir}/loaddb_${2}.log

if [ -e ${loadlog_file} ]; then
  mv ${loadlog_file} ${db_dir}/..
fi

echo "${CUBRID}/compat/${convert_program} ${2}"
${CUBRID}/compat/${convert_program} ${2}
if [ $? != 0 ]; then
  echo "Can not convert password"
  exit 1
fi

